/* Configuring multi host using ppp */

/* Modify the following as required */
lan_card = 0	   /* The Lan interface number to publish the arp addresses */
gateway='65'	   /* last part of router IP number on your network */
pppcom1 = 'com4' /* Used for the ppp command */
pppcount = 32	   /* Number of PPP ports to assign */
pppstart = '192'   /* One less than the starting IP number for VHost IPs */
/* If this server is backing up another server          */
/* Change the localhost IP numer to the primary IP */
/* of the server being backed up                          */
/* DO NOT start until the primary server is offline    */
LocalHost = '127.0.0.1'

/* Load the REXX function Library */
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs
Call RxFuncAdd 'SockLoadFuncs' ,'RxSock', 'SockLoadFuncs'
Call SockLoadFuncs

/*
say 'Wait 10 seconds for TCP/IP to start'
say 'Press Ctrl/C to cancel'
call SysSleep 10
*/
'@echo=off' 

/* Set the variables up */
 ipnumber = Get_IP() 
say 'IPNUMBER:'ipnumber
position = LastPos('.',ipnumber)
Network = Substr(ipnumber,1,position)
IPnumber = Substr(ipnumber,position+1)

say 'Network IP is 'Network', this host is 'Network||IPnumber

/* Get the adapter internal address for the lan_card interface */
/*id = Get_Enet( lan_card )*/
id = '00c0f0097226'

lan_id = substr(id,1,2)':'substr(id,3,2)':'substr(id,5,2)':'substr(id,7,2)':'substr(id,9,2)':'substr(id,11,2)

say 'ARP entries will be published  on Lan Card:'lan_id

/*say 'Wait 10 seconds for testing, Ctrl+Break to cancel'
call SysSleep 10*/

/* Do the setup.cmd bit */
	say 'route -fh'
	say 'arp -f'
	say
	say 'ifconfig lan0 'Network||ipnumber' netmask 255.255.255.0'
	say 'route add default 'Network||gateway' 1'
	say 'ipgate on'
	say

/* Configure the loopback interface (if not already done */
say 'Configuring local loopback'
	    'ifconfig lo 'localhost''
say

If LocalHost <> '127.0.0.1' then do
	say 'Publishing localhost on Ethernet'
	'arp -s 'localHost Lan_ID' pub'
end
/************************************* PPP PORTS */

Do_ppp:

/* The following PPP code kindly supplied by: */
/* Author : Al Nichols                                Language: REXX    */
/* modified: Derek Sims, October 1996*/
/* Title  : Virtual2.cmd                              Date    : 07Jun95 */
/* Purpose: Configure all available interfaces for virtual IP addresses */
/*          outside of ppp0 which is the main(real) link                */
/* IO     : the slip command uses the file slip.cfg in the tcpip\bin dir*/
/* Changes: use point to point instead of slip to make it self contained*/

/* Now start the PPP interfaces */
do index = 1 to pppcount
   say 'Starting ppp 'pppcom1 'for' Network||pppstart+index
   "detach ppp silent "pppcom1" 28800 mru 1500 priority 1"
/*   "start /N /MIN ppp silent "pppcom1" 28800 mru 1500 priority 1"*/
  say 'ppp'index 'PPP rc is:'rc
   rc=syssleep(4)
end

/* Now configure the ppp interfaces */
Do i = 1 to pppcount
say 'Configuring port 'Network||pppstart+i' on ppp 'i-1
	'ifconfig ppp'i-1' 'Network||pppstart+i'  'localhost''
	'route delete 'localhost' 'Network||pppstart+i  /* delete spurious route */
end
say

Do i = 1 to pppcount
say 'Configuring ARP 'Network||pppstart+i' on Lan 'lan_id
	/* Now publish the ip address on ethernet */
	'arp -s 'Network||pppstart+i lan_id' pub'

	/* and now add the appropriate routes */
	'route add host 'Network||pppstart+i' 'localhost' 0'
end
say 'PPP Set-up done'
/*
say ' You can now try to cancel the ppp drivers !!! '
pause
*/
Do Index = 1 to pppcount
	line=linein('C:/mptn/etc/ppp'index-1'.pid')
	call lineout 'C:/mptn/etc/ppp'index-1'.pid'
	say 'ppp'index-1 'pid is:'line
	'kill 'line
end

/*************************************END PPP PORTS */

'netstat -r'
'arp -a'

/* Testing */
/*
say 'Ready to start servers, press Ctrl/c to cancel'
'Pause'
*/

/* The following code may be deleted. I use it to start */
/* various WWW, FTP anf other servers that must be */
/* started after the IP addresses are set                       */


/* start the web server */
say 'starting web server'
'start D:\Goserv\Golive.cmd'
call syssleep 5

/* start the ftp server */
say 'starting FTP server'
'start D:\penguin_ftp\penguin.cmd'
call syssleep 5


/* start the count server */
say 'Starting WWW Count server'
'd:'
'cd \count_server'
'start D:\count_server\countstart.cmd'
call syssleep 5

/* Start Mail server */
say 'Starting Mail SMTP and POP server'
'D:'
'cd \InetMail'
'start D:\InetMail\InetMail.exe'

say 'Exiting'
return

/*************************************************/
/* Do not delete the following procedures */
/*                                                               */

Get_IP: procedure
/* Return the this host's IP address */

return SockGetHostID()


Get_Enet:
/*
    NOTE This does NOT work if multiple interface are defines, netstat hangs for input
	Returns the first Ethernet adapter internal address 
*/
parse arg number
   PUSH '                    '
    'netstat -n > temp2'
    notfound = 1
    data = ''
    Do while lines('temp2') 
        data = data||linein('temp2')
    end
    call lineout 'temp2' /* Close temp */

    Do while data <> '' & notfound
        data = Strip(data)
        parse var data . 'Interface' string 'MTU' data
/* NOTE various versions of netstat give slightly different formats*/
/* Please check and change as required */
        Parse var string LanCard':' . 'address' ENet .
        If LanCard = number then do
            return ENet
            notfound = 0
        end
    end
say 'Error Lan Interface 'number' Not Found'
return ''
/* End of program */
/* pipe char = | */