/* Verify the user is authorised for this transaction */
parse arg Global.!Auth_Realm, Global.Remote_User, Global.!Server_Name Global.!Domain
    signal on halt
    /* Verify that the user is in Realm "Admin" */
    If Translate(Global.!Auth_Realm) <> 'ADMIN' | Global.!Remote_User == '' then do
        say 'You are not authorised for this transaction 1 '
        return 1
    end
    /* Verify the Requested domain is same as the target */
    If Translate(Global.!Server_Name) <> Translate(Global.!Domain) then do
        /* Verify that the user is in the "Home" IP address of the server*/
        myaddr = SockGetHostId()
        rc = SockGetHostByName(Global.!Server_Name,'Host.!')
        If Host.!Addr <> myaddr then do
            say 'You are not authorised for this transaction 2'
            return 1
        end
    end 
return 0

    signal _VREMain
