/* Custom mainline for macro */

        signal _VREMain


_VREMain:
/*:VRX         Main
*/
Main:
    signal on halt
    Parse arg list

    call RXFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
    call SysLoadFuncs

    If list == '*' then do
        rc = SysFileTree('*.cmd', 'FileList','FO')
        do i = 1 to FileList.0
            say FileList.i
            ok = StripVX(FileList.i)
        end
    end

    else do    
        ok=StripVX(list)
    end

return 1

/*:VRX         Halt
*/
Halt:

exit

/*:VRX         StripVX
*/
StripVX: procedure
    Parse arg filename
    If Translate(filename) = 'STRIPVX.CMD' then return 0

    size = Stream( filename, "Command", "Query Size" )
    strm_status = Stream( filename, "Command", "Open Read" )
    If Strm_Status == 'READY:' then do
        char  = CharIn( filename, 1, size )
        strm_status = Stream( filename, "Command", "Close" )
    
        position  = Pos( 'call RXFuncAdd "VRLoadFuncs"', char, 1 )
        If position > 100 then return 0

        /* Find the prologue code */
        parse var char start 'call RXFuncAdd "VRLoadFuncs"' junk 'exit 32000' code

        char = start || '    signal _VREMain'||'0d0a'x || code

        'del 'filename 
        count  = CharOut( filename, char, 1 )
        strm_status = Stream( filename, "Command", "Close" )
    end

    else do
        say 'File 'filename' not accessible'
        return 0
    end

return 1

