/* Configuring multi host using slip */
/* 
first configure slip.cfg in mptn/etc as follows:

'interface sl0 { device="com2" }'
'interface sl1 { device="com2" }'
'interface sl2 { device="com2" }'
'interface sl3 { device="com2" }'
'interface sl4 { device="com2" }'
*/

lan_card = 2
ipnumber = '73'
gateway='194.70.219.65'
slipstart = '192'
slipcount = 10


/* Load the REXX function Library */
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs
say 'Wait 30 seconds for TCP/IP to start'
call SysSleep 30

/* Get the adapter internal address for the lan_card interface */
/* need some more ode to extract this from 'netstat'? */

id='00c0f00cadb6'

lan_id = substr(id,1,2)':'substr(id,3,2)':'substr(id,5,2)':'substr(id,7,2)':'substr(id,9,2)':'substr(id,11,2)

/* Do the setup.cmd bit */
/*	say 'route -fh'
	say 'arp -f'
	say
	say 'ifconfig lan0 194.70.219.'ipnumber' netmask 255.255.255.0'
*/
/* Do the setup.cmd bit */
/*	say 'route add default 'gateway' 1'
	say 'ipgate on'
	say
*/
/* Configure the loopback interface (if not already done */
say 'Configuring local loopback'
	    'ifconfig lo 127.0.0.1'
say

/* then start slip */
say 'Starting SLIP'
'start slip' 
/* wait a few seconds for SLIP to start */
say 'waiting 10 seconds'
call syssleep 10


/* Now configure the slip interfaces */
Do i = 1 to slipcount
say
	'ifconfig sl'i-1' 194.70.219.'slipstart+i'  127.0.0.1'
	'route delete 127.0.0.1 194.70.219.'slipstart+i /* delete spurious route */
end
say
Do i = 1 to slipcount
say
	/* Now publish the ip address on ethernet */
	'arp -s 194.70.219.'slipstart+i lan_id' pub'

	/* and now add the appropriate routes */
	'route add host 194.70.219.'slipstart+i' 127.0.0.1 0'
end
say
say
/* slip can now be cancelled */
'netstat -r'
'arp -a'

/* start the wb server */
say 'starting web server'
start Golive.cmd
call syssleep 5

/* start the ftp server */
say 'starting FTP server'
start 'D:\penguin_ftp\penguin.cmd'
call syssleep 5

/* start the count server */
say 'Starting WWW Count server'
'd:'
'cd \count_server'
start 'D:\count_server\ctserver.exe d:\count_server\gparam'
call syssleep 5

say 'Exiting'
return